export const colorLegend = (selection, props) => {
  
  const { colorScale, 
         circleRadius, 
         spacing, 
         textOffset,
         backgroundRectWidth } = props;
  
  // This is just the update selection. 
  const groups = selection.selectAll('g').data(colorScale.domain());
  
  const groupsEnter = groups.enter().append('g');
  
  const n = colorScale.domain().length;
  
  const backgroundRect = selection.selectAll('rect')
  	.data([null]);
  backgroundRect.enter().append('rect')
  	.merge(backgroundRect)
  		.attr('x', -circleRadius * 2)
  		.attr('y', -circleRadius * 2)
      .attr('width', backgroundRectWidth)
      .attr('height', n * spacing + circleRadius * 0.5)
      .attr('fill', 'grey')
  		.attr('rx', circleRadius * 2)
  		.attr('opacity', 0.3)
  
  groupsEnter
    .merge(groups)
    	.attr('transform', (d, i) => `translate(0, ${i * spacing})`);
  groups.exit().remove();
  
  groupsEnter.append('circle')
  		// .attr('cx', xPosition)
  		// .attr('cy', height/2)
  	.merge(groups.select('circle'))
      .attr('r', circleRadius)
  		.attr('fill', colorScale);
  
  groupsEnter.append('text')
  		// .attr('cx', xPosition)
  		// .attr('cy', height/2)
  	.merge(groups.select('text'))
      .text(d => d)
  		.attr('x', textOffset)
  		.attr('dy', '0.32em');
};